<template>
      <div>

        <q-btn @click="loadJobs()" color="green">Refresh</q-btn>
        <q-list highlight>
          <q-list-header>Jobs <span class="on-right">{{ jobs.length }}</span></q-list-header>
          <q-item v-for="r in jobs" :key="r.id" @click="select(r)">
            <q-item-side>
              <q-item-tile>
                <!-- {{ Math.round(r.experience/12) }} Yrs. -->
                {{ r.skills.length }}
              </q-item-tile>
            </q-item-side>
            <q-item-main>{{ r.name }}</q-item-main>
            <q-item-side right>
              <!-- <q-item-tile icon="chat_bubble" color="green" /> -->
              <q-item-tile>
                <q-btn v-on:click="deleteItem(r.id)" color="red">Delete</q-btn>
              </q-item-tile>
            </q-item-side>
          </q-item>
        </q-list>

        <q-modal v-model.lazy="showmodal" maximized>
          <q-modal-layout>
            <q-toolbar slot="header">
              <q-btn
                flat
                round
                dense
                @click="unselect()"
                icon="reply"
                wait-for-ripple
              />
              <q-toolbar-title>
                {{ selected.name }}
              </q-toolbar-title>
            </q-toolbar>

<!--             <q-toolbar slot="footer">
              <q-toolbar-title>
                Footer
              </q-toolbar-title>
            </q-toolbar> -->

            <div class="layout-padding q-pa-sm">
              
                <q-list highlight>
                <q-list-header>Resumes <span class="on-right">{{ totalmatches }}</span></q-list-header>
                <q-item v-for="r in jobmatches" :key="r.id">
                  <q-item-side>
                    <q-item-tile>
                      {{ Math.round(r.experience/12) }} Yrs.
                    </q-item-tile>
                  </q-item-side>
                  <q-item-main>{{ r.stacks[0].stack[0] }}</q-item-main>
                  <q-item-side right>
                    <!-- <q-item-tile icon="chat_bubble" color="green" /> -->
                    <q-item-tile>
                      <q-btn v-on:click="deleteItem(r.id)" color="red">Delete</q-btn>
                    </q-item-tile>
                  </q-item-side>
                </q-item>
              </q-list>

              <q-card>
                <q-card-title class="bg-primary text-white">Job Details</q-card-title>
                <q-card-separator />
                <q-card-main>
                  <q-chip v-for="skill in selected.skills" :bind="skill.id" color="info">{{ skill.name }}</q-chip>
                  <p class="text-faded"
                  v-for="line in selected.lines"
                  :bind="line">{{ line }}</p>
                </q-card-main>
              </q-card>

            </div>
          </q-modal-layout>
        </q-modal>

      </div>
</template>

<script>
import taleanconnector from './taleanconnector'
import {
  QBtn,
  QIcon,
  QList,
  QListHeader,
  QItem,
  QItemSide,
  QItemMain,
  QItemSeparator,
  QItemTile,
  QToolbar,
  QToolbarTitle,
  QModal,
  QModalLayout,
  QCard,
  QCardSeparator,
  QCardTitle,
  QCardMain,
  QChip
} from 'quasar'

export default {
  name: 'jobs',
  components: {
    QBtn,
    QIcon,
    QList,
    QListHeader,
    QItem,
    QItemSide,
    QItemMain,
    QItemSeparator,
    QItemTile,
    QToolbar,
    QToolbarTitle,
    QModal,
    QModalLayout,
    QCard,
    QCardSeparator,
    QCardTitle,
    QCardMain,
    QChip
  },
  data () {
    return {
      jobs: [],
      showmodal: false,
      selected: {},
      jobmatches: [],
      totalmatches: 0,
      matcheson: false
    }
  },
  created: function () {
    this.loadJobs()
  },
  computed: {
  },
  methods: {
    loadJobs () {
      taleanconnector.getUserJobs(this.$session.get('userid'))
        .then((data) => {
          console.log(data)
          this.jobs = data
          // this.totalmatches = data.total
        })
        .catch((err) => {
          // console.log(err)
          console.log('error occurred loading jobs', err)
        })
    },
    deleteItem (id) {
      taleanconnector.deleteresume(id)
        .then((data) => {
          // console.log(data)
        })
        .catch((err) => {
          // console.log(err)
          console.log('error occurred deleting job: ' + id, err)
        })
    },
    select (job) {
      this.selected = job
      this.showmodal = true
      this.getjobmatches()
    },
    unselect () {
      this.selected = {}
      this.showmodal = false
      this.matcheson = false
    },
    getjobmatches () {
      let terms = this.selected.skills.map((val) => {
        return val.name
      })
      taleanconnector.getjobmatches(this.$session.get('userid'), terms)
        .then((response) => {
          console.log(response)
          this.jobmatches = response.data
          this.totalmatches = response.total
          this.matcheson = true
        })
        .catch((err) => {
          console.log('error occurred getting job matches for user ' + this.$session.get('userid'), err)
        })
    }
  },
  mounted () {
  },
  beforeDestroy () {
  }
}
</script>

<style lang="stylus">
  p
    margin 0
</style>
